import React, { useRef, useState, useEffect } from 'react';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "/* Original CSS written by Oliver Geer (WebCoder49) */\n/* https://css-tricks.com/creating-an-editable-textarea-that-supports-syntax-highlighted-code/ */\n/* Updated for solid-code-input */\n\n.styles-module_outer-wrapper__bpb5n * {\n  box-sizing: border-box;\n}\n\n.styles-module_wrap__cr2wW {\n  position: relative;\n  display: block;\n  box-sizing: border-box;\n  top: 0;\n  left: 0;\n  overflow: hidden;\n  min-height: 76px;\n  font-size: 16px;\n  font-family: monospace;\n  line-height: normal;\n  tab-size: 2;\n  caret-color: darkgrey;\n  white-space: pre;\n}\n\n.styles-module_wrap__cr2wW textarea {\n  background: transparent;\n}\n\n.styles-module_wrap__cr2wW textarea,\n.styles-module_wrap__cr2wW pre {\n  width: 100%;\n  height: 100%;\n  border: none;\n  overflow: auto;\n  outline: none;\n  position: absolute;\n  top: 0;\n  left: 0;\n  font-family: monospace;\n  font-size: inherit !important;\n  line-height: inherit !important;\n  padding: 0 !important;\n  margin: 0 !important;\n}\n\n.styles-module_wrap__cr2wW textarea,\n.styles-module_wrap__cr2wW pre,\n.styles-module_wrap__cr2wW pre * {\n  font-size: inherit !important;\n  font-family: inherit !important;\n  line-height: inherit !important;\n  tab-size: inherit !important;\n}\n\n.styles-module_wrap__cr2wW textarea {\n  display: block;\n  color: transparent;\n  background: transparent;\n  caret-color: inherit !important;\n  z-index: 1;\n}\n\n.styles-module_wrap__cr2wW pre::-webkit-scrollbar {\n  width: 0;\n  height: 0;\n}\n\n.styles-module_wrap__cr2wW pre {\n  z-index: 0;\n}\n\n.styles-module_wrap__cr2wW textarea,\n.styles-module_wrap__cr2wW pre {\n  overflow: auto !important;\n  white-space: inherit;\n  word-spacing: normal;\n  word-break: normal;\n  word-wrap: normal;\n}\n\n.styles-module_wrap__cr2wW textarea.styles-module_resize-both__E84g7 {\n  resize: both;\n}\n\n.styles-module_wrap__cr2wW textarea.styles-module_resize-none__K-46N {\n  resize: none;\n}\n\n.styles-module_wrap__cr2wW textarea.styles-module_resize-horizontal__td6a8 {\n  resize: horizontal;\n}\n\n.styles-module_wrap__cr2wW textarea.styles-module_resize-vertical__i2O6N {\n  resize: vertical;\n}\n";
var styles = {"outer-wrapper":"styles-module_outer-wrapper__bpb5n","wrap":"styles-module_wrap__cr2wW","resize-both":"styles-module_resize-both__E84g7","resize-none":"styles-module_resize-none__K-46N","resize-horizontal":"styles-module_resize-horizontal__td6a8","resize-vertical":"styles-module_resize-vertical__i2O6N"};
styleInject(css_248z);

/* Original Code written by Oliver Geer (WebCoder49) */
// https://github.com/WebCoder49/code-input/blob/main/plugins/indent.js
function handleTabKey(event, input_element, code) {
    event.preventDefault(); // stop normal
    if (!event.shiftKey &&
        input_element.selectionStart == input_element.selectionEnd) {
        // Shift always means dedent - this places a tab here.
        var before_selection = code.slice(0, input_element.selectionStart); // text before tab
        var after_selection = code.slice(input_element.selectionEnd, input_element.value.length); // text after tab
        var cursor_pos = input_element.selectionEnd + 1; // where cursor moves after tab - moving forward by 1 char to after tab
        input_element.value = before_selection + '\t' + after_selection; // add tab char
        // move cursor
        input_element.selectionStart = cursor_pos;
        input_element.selectionEnd = cursor_pos;
    }
    else {
        var lines = input_element.value.split('\n');
        var letter_i = 0;
        var selection_start = input_element.selectionStart; // where cursor moves after tab - moving forward by 1 indent
        var selection_end = input_element.selectionEnd; // where cursor moves after tab - moving forward by 1 indent
        var number_indents = 0;
        var first_line_indents = 0;
        for (var i = 0; i < lines.length; i++) {
            letter_i += lines[i].length + 1; // newline counted
            if (input_element.selectionStart <= letter_i &&
                input_element.selectionEnd >= letter_i - lines[i].length) {
                // Starts before or at last char and ends after or at first char
                if (event.shiftKey) {
                    if (lines[i][0] == '\t') {
                        // Remove first tab
                        lines[i] = lines[i].slice(1);
                        if (number_indents == 0)
                            first_line_indents--;
                        number_indents--;
                    }
                }
                else {
                    lines[i] = '\t' + lines[i];
                    if (number_indents == 0)
                        first_line_indents++;
                    number_indents++;
                }
            }
        }
        input_element.value = lines.join('\n');
        // move cursor
        input_element.selectionStart = selection_start + first_line_indents;
        input_element.selectionEnd = selection_end + number_indents;
    }
}
function handleEnterKey(event, input_element) {
    event.preventDefault();
    var lines = input_element.value.split('\n');
    var letter_i = 0;
    var current_line = lines.length - 1;
    var new_line = '';
    var number_indents = 0;
    // find the index of the line our cursor is currently on
    for (var i = 0; i < lines.length; i++) {
        letter_i += lines[i].length + 1; // newline counted
        if (input_element.selectionStart <= letter_i) {
            current_line = i;
            break;
        }
    }
    // count the number of indents the current line starts with (up to our cursor position in the line)
    var cursor_pos_in_line = lines[current_line].length - (letter_i - input_element.selectionEnd) + 1;
    for (var i = 0; i < cursor_pos_in_line; i++) {
        if (lines[current_line][i] == '\t') {
            number_indents++;
        }
        else {
            break;
        }
    }
    // determine the text before and after the cursor and chop the current line at the new line break
    var text_after_cursor = '';
    if (cursor_pos_in_line != lines[current_line].length) {
        text_after_cursor = lines[current_line].substring(cursor_pos_in_line);
        lines[current_line] = lines[current_line].substring(0, cursor_pos_in_line);
    }
    // insert our indents and any text from the previous line that might have been after the line break
    for (var i = 0; i < number_indents; i++) {
        new_line += '\t';
    }
    new_line += text_after_cursor;
    // save the current cursor position
    var selection_start = input_element.selectionStart;
    var selection_end = input_element.selectionEnd;
    // splice our new line into the list of existing lines and join them all back up
    lines.splice(current_line + 1, 0, new_line);
    input_element.value = lines.join('\n');
    // move cursor to new position
    input_element.selectionStart = selection_start + number_indents + 1; // count the indent level and the newline character
    input_element.selectionEnd = selection_end + number_indents + 1;
}

var CodeInput = function (props) {
    var preElement = useRef(null);
    var textAreaElement = useRef(null);
    var wrapperElement = useRef(null);
    var outerElement = useRef(null);
    // Used to detect when the user manually resizes the wrapper with handle
    var wrapperHeight;
    var wrapperWidth;
    var _a = useState(false), manualResize = _a[0], setManualResize = _a[1];
    useEffect(function () {
        watchResize();
        if (props.autoHeight) {
            autoHeight();
        }
        setBackgroundWrapper();
    }, []);
    useEffect(function () {
        setBackgroundWrapper();
    });
    useEffect(function () {
        codeTokens();
    }, [props.language]);
    function setBackgroundWrapper() {
        if (outerElement.current) {
            outerElement.current.style.backgroundColor = window.getComputedStyle(preElement.current).backgroundColor;
        }
    }
    function setSizes() {
        setBackgroundWrapper();
        var _a = getTextareaSize(), height = _a.height, width = _a.width;
        if (preElement.current && wrapperElement.current && outerElement.current) {
            preElement.current.style.width = "".concat(width, "px");
            preElement.current.style.height = "".concat(height, "px");
            wrapperElement.current.style.width = "".concat(width, "px");
            wrapperElement.current.style.height = "".concat(height, "px");
            // calculate what 1rem is in pixels
            var rem = parseFloat(window.getComputedStyle(document.documentElement).fontSize);
            outerElement.current.style.width = "".concat(width + rem, "px");
            outerElement.current.style.height = "".concat(height + rem, "px");
        }
    }
    function getTextareaSize() {
        if (textAreaElement.current) {
            var _a = textAreaElement.current.getBoundingClientRect(), height = _a.height, width = _a.width;
            return { height: height, width: width };
        }
        return {
            height: 0,
            width: 0,
        };
    }
    function autoHeight() {
        if (manualResize) {
            return;
        }
        if (wrapperElement.current && textAreaElement.current) {
            wrapperElement.current.style.height = "0px";
            wrapperElement.current.style.height =
                textAreaElement.current.scrollHeight + 'px';
        }
    }
    function watchResize() {
        new ResizeObserver(setSizes).observe(textAreaElement.current);
    }
    function syncScroll() {
        if (preElement.current === null || textAreaElement.current === null)
            return;
        preElement.current.scrollTop = textAreaElement.current.scrollTop;
        preElement.current.scrollLeft = textAreaElement.current.scrollLeft;
        // Prevents a scrolling issue when the user manually resizes the wrapper
        if (textAreaElement.current.scrollTop > preElement.current.scrollTop) {
            textAreaElement.current.scrollTop = preElement.current.scrollTop;
        }
        if (textAreaElement.current.scrollLeft > preElement.current.scrollLeft) {
            textAreaElement.current.scrollLeft = preElement.current.scrollLeft;
        }
    }
    var codeTokens = function () {
        try {
            if (props.prismJS) {
                if (props.prismJS.languages[props.language]) {
                    if (props.autoHeight) {
                        autoHeight();
                    }
                    var tokens = props.prismJS.highlight(props.value, props.prismJS.languages[props.language], props.language);
                    return tokens;
                }
                else {
                    if (props.autoHeight) {
                        autoHeight();
                    }
                    return props.prismJS.util.encode(props.value).toString();
                }
            }
            else if (props.highlightjs) {
                // @ts-ignore
                var tokens = props.highlightjs.highlight(props.value, {
                    language: props.language,
                }).value;
                if (props.autoHeight) {
                    autoHeight();
                }
                return tokens;
            }
        }
        catch (e) {
            console.error(e);
        }
    };
    function handleKeyDown(event) {
        var input_element = textAreaElement.current;
        var code = input_element.value;
        if (event.key === 'Tab') {
            handleTabKey(event, input_element, code);
            props.onChange(input_element.value);
        }
        if (event.key === 'Enter') {
            handleEnterKey(event, input_element);
            props.onChange(input_element.value);
        }
    }
    function handleInput(e) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                props.onChange(e.target.value);
                return [2 /*return*/];
            });
        });
    }
    function handleMouseDown() {
        var _a = getTextareaSize(), height = _a.height, width = _a.width;
        wrapperHeight = height;
        wrapperWidth = width;
    }
    function handleMouseUp() {
        var _a = getTextareaSize(), height = _a.height, width = _a.width;
        if (height !== wrapperHeight || width !== wrapperWidth) {
            setManualResize(true);
        }
    }
    return (React.createElement("div", { ref: outerElement, style: {
            padding: '1rem',
            boxSizing: "border-box",
        }, className: styles['outer-wrapper'] },
        React.createElement("div", { onMouseDown: handleMouseDown, onMouseUp: handleMouseUp, ref: wrapperElement, className: styles.wrap },
            React.createElement("textarea", { className: "".concat(props.resize ? styles["resize-".concat(props.resize)] : ''), spellCheck: false, onKeyDown: handleKeyDown, onInput: handleInput, onScroll: syncScroll, ref: textAreaElement, placeholder: props.placeholder || 'Type code here...', value: props.value }),
            React.createElement("pre", { ref: preElement, className: "language-".concat(props.language), "aria-hidden": true },
                React.createElement("div", { dangerouslySetInnerHTML: { __html: codeTokens() || '' }, className: "code-highlighted" })))));
};

export { CodeInput };
